package lectura_ficheros;
import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.lang.String;
import java.util.StringTokenizer;

public class FicheroTabular {
	
	public ContenidoFichero contenido;
	public int numMuestras;
	public int numCols;
	public float min;
	public float max;
	
	String fichero;
	char separador;
	int num_linea_objeto_de_estudio;
	int num_linea_unidades;
	int num_linea_fecha;
	int num_linea_comienzo_datos;

	
	public FicheroTabular (){
		fichero = null;
		separador = '\t';
		num_linea_objeto_de_estudio = num_linea_unidades =	num_linea_fecha = 0;
		contenido = new ContenidoFichero();
	}
	
	public FicheroTabular (String afichero, int anum_linea_objeto_de_estudio, int anum_linea_unidades, int anum_linea_fecha, int anum_linea_comienzo_datos){
		fichero = afichero;
		separador = '\t';
		num_linea_objeto_de_estudio = anum_linea_objeto_de_estudio;
		num_linea_unidades = anum_linea_unidades;
		num_linea_fecha = anum_linea_fecha;
		num_linea_comienzo_datos = anum_linea_comienzo_datos;
		contenido = new ContenidoFichero();
	}
	
	public FicheroTabular (String afichero, char aseparador, int anum_linea_objeto_de_estudio, int anum_linea_unidades, int anum_linea_fecha, int anum_linea_comienzo_datos){
		fichero = afichero;
		separador = aseparador;
		num_linea_objeto_de_estudio = anum_linea_objeto_de_estudio;
		num_linea_unidades = anum_linea_unidades;
		num_linea_fecha = anum_linea_fecha;
		num_linea_comienzo_datos = anum_linea_comienzo_datos;
		contenido = new ContenidoFichero();
	}
	
	public String[] leerMetadatosdeFTabular() throws IOException{

		FileReader fr = null;
		BufferedReader entrada = null;
		String linea_aux=null, obj_estudio=null, unids=null, data=null;

		try {
			fr = new FileReader(fichero);
			entrada = new BufferedReader(fr);
			int cont = 0;
			int maximo = seleccionaMaximoDe3(num_linea_objeto_de_estudio, num_linea_unidades, num_linea_fecha);
			
			//TODO ver si num_linea = 0, caso de no existir un campo, p.e. unidades
			//bucle donde organizaremos los metadatos de las tablas
			//objeto de estudio, unidades y fecha
			do {
				cont++;
				linea_aux = entrada.readLine();
				if (cont == num_linea_objeto_de_estudio){
					obj_estudio = tratarLineaOE(linea_aux);
				}
				if (cont == num_linea_unidades){
					unids = tratarLineaUds(linea_aux);
				}
				if (cont == num_linea_fecha){
					//TODO ver si hay mas de una
					data = tratarLineaFecha(linea_aux);
				}
				
			} while ((linea_aux != null) && (cont != maximo));
			
			//PanelOpciones po= new PanelOpciones("Modificacion de datos", obj_estudio,unids,data,data);

			//TODO introducir "lugar"
			//guardamos los datos en el vector de String
			String[] metadatos = new String[4]; 
			metadatos[0] = obj_estudio;
			metadatos[1] = unids;
			metadatos[2] = data;
			metadatos[3] = data;//TODO data->lugar
			
			contenido.setMetadatos(metadatos);
		
		}finally{
			try{                    
				if( null != fr ){   
					fr.close();     
				}                  
			}catch (Exception e2){ 
				e2.printStackTrace();
			}
		}//TODO hacer metadatos variable de clase?
		return contenido.getMetadatos();
	}
	
	
	private String tratarLineaFecha(String linea_aux) {
		//caso: varias columnas con diferentes fechas
		StringTokenizer st = new StringTokenizer(linea_aux, Character.toString(separador));
		String linea_procesada = new String(st.nextToken());
		int numTokens = st.countTokens();
		if (numTokens > 1){
			for (int i=0; i<numTokens; i++){
				linea_procesada = (linea_procesada + ";" + st.nextToken());
			}
		}
		//caso: la fecha est mezclada con texto
		//TODO
		return linea_procesada;
	}
//TODO corregir fichero del agua. Desagrupar datos
	private String tratarLineaUds(String linea_aux) {
		StringTokenizer st = new StringTokenizer(linea_aux, ":");
		int numTokens = st.countTokens();
		
		String linea_procesada = new String(st.nextToken());

		if (numTokens>1 && linea_procesada.compareToIgnoreCase("unidades") == 0){
			int pos = linea_aux.indexOf(":");
			linea_procesada = linea_aux.substring(pos+1);
		}
		return linea_procesada;
	}

	private String tratarLineaOE(String linea_aux) {
		StringTokenizer st = new StringTokenizer(linea_aux, Character.toString(separador));
		String linea_procesada = new String(st.nextToken());
		int numTokens = st.countTokens();
		if (numTokens > 1){
			for (int i=0; i<numTokens; i++){
				linea_procesada = (linea_procesada + ";" + st.nextToken());
			}
		}
		
		return linea_procesada;
	}

	private int seleccionaMaximoDe3(int uno, int dos, int tres) {
		int vmax = uno;
		if (dos > vmax)
			vmax = dos;
		if (tres > vmax)
			vmax = tres;
		return vmax;
	}


	//rescata la tabla en una estructura ContenidoFichero
	//y despues de eso ignora el resto del fichero
	public Tabla leerDatosdeFTabular() throws IOException{
		FileReader fr = null;
		BufferedReader entrada = null;
		StringTokenizer st = null;
		
		try {
			fr = new FileReader(fichero);
			entrada = new BufferedReader(fr);
			String linea_aux = entrada.readLine();
			st = new StringTokenizer (linea_aux, Character.toString(separador));
			numCols = st.countTokens();
			boolean fin_tabla = false;
			
			do {
				st = new StringTokenizer (linea_aux, Character.toString(separador));
				//condicion para descartar lineas sin datos del final del fichero
				if (st.countTokens() != numCols){
					fin_tabla=true;
				}
				contenido.insertaFila(st);
			}while (entrada.readLine() != null && !fin_tabla);
			
		}finally{
			try{                    
				if( null != fr ){   
					fr.close();     
				}                  
			}catch (Exception e2){ 
				e2.printStackTrace();
			}
		}
		return contenido.getDatos();
	}
}

